//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include "About.h"
#include "Search.h"
#include "Albums.h"

//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMainForm *MainForm;
TRect rct;
Graphics::TBitmap* bitmap=new Graphics::TBitmap();
Graphics::TBitmap* bitmap1=new Graphics::TBitmap();
HDC dc;   TCanvas* dt;
bool SlideShow=false;
//---------------------------------------------------------------------------

__fastcall TMainForm::TMainForm(TComponent *Owner)
	: TForm(Owner) {
}
//---------------------------------------------------------------------------

MENUITEMINFO info;
void __fastcall TMainForm::ProcessMenu(TMessage &Message) {
 Word wID = LOWORD(Message.WParam);
 GetMenuItemInfo(
    MainMenu1->Handle,
    wID,
    false,
    &info
   );
 for (int i=0;i< (File1->Count);i++)
 if (i==wID-2)
  File1->Items[i]->OnDrawItem=FileNewItem->OnDrawItem;
}

TMDIChild* __fastcall TMainForm::CreateMDIChild(AnsiString Name) {
 TMDIChild *Child;
 Child = new TMDIChild(Application);
 Child->Caption = Name;
 return Child;
}

TMDIChild1* __fastcall TMainForm::CreateMDIChild1(const String Name,TListItem* curr) {
 TMDIChild1 *Child;
 Child = new TMDIChild1(Application);
 Child->Caption = Name;
 Child->cur=curr;
 try {
  Child->Image1->Picture->LoadFromFile(Name);
 }
 catch(...) {
  Child->Image1->Picture=NULL;
 }
 ((TMainForm*)(Application->MainForm))->ToolBar2->Visible=false;
 ((TMainForm*)(Application->MainForm))->ToolBar1->Visible=true;
 return Child;
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::FileNew1Execute(TObject *Sender) {
 CreateMDIChild("");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileOpen1Execute(TObject *Sender) {
 if (OpenDialog->Execute()) {
  MainForm->TabControl1->Tabs->AddObject(ExtractFileName(OpenDialog->FileName)+"     [X]",CreateMDIChild1(OpenDialog->FileName,NULL));
  MainForm->TabControl1->Visible=true ? MainForm->TabControl1->Tabs->Count>=0 :MainForm->TabControl1->Tabs->Count==0;
 }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::HelpAbout1Execute(TObject *Sender) {
 AboutBox->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileExit1Execute(TObject *Sender) {
 Close();
}
//---------------------------------------------------------------------------

TMDIChild* Browser;

void __fastcall TMainForm::FormShow(TObject *Sender) {
 TMDIChild1* Child;
 int i;
 MainForm->TabControl1->Tabs->Clear();
 MainForm->TabControl1->Tabs->AddObject(" [X]",CreateMDIChild(""));
 MainForm->TabControl1->Visible=true ? MainForm->TabControl1->Tabs->Count>=0 :MainForm->TabControl1->Tabs->Count==0;
 for(i=0;i<MainForm->MDIChildCount;i++) {
  if(MainForm->MDIChildren[i]->Name==AnsiString("MDIChild"))
  Browser= ((TMDIChild*)(MainForm->MDIChildren[i]));
 }
 if(ParamCount()>0) {
  TListItem *Item;
  Browser->DirectoryListBox1->OnChange(Browser->DirectoryListBox1);
  Browser->DirectoryListBox1->Directory=ExtractFileDir(ParamStr(1));
  Item=Browser->ListView1->FindCaption(0,ExtractFileName(ParamStr(1)),true,true,true);
  MainForm->TabControl1->Tabs->AddObject(ExtractFileName(ParamStr(1))+"     [X]",CreateMDIChild1(ParamStr(1),Item));
 }

 ((TMainForm*)(Application->MainForm))->ToolBar1->ParentColor=false;
 ((TMainForm*)(Application->MainForm))->ToolBar1->Transparent=false;
 ((TMainForm*)(Application->MainForm))->ToolBar1->Color=clBtnFace;
 bitmap->LoadFromFile(ExtractFilePath(Application->ExeName)+"\\img\\p140.Bmp");
 bitmap1->LoadFromFile(ExtractFilePath(Application->ExeName)+"\\img\\p141.Bmp");
 //   , ..     
 ((TWinControl*)this->ToolBar1)->Brush->Bitmap=(bitmap);
 ((TWinControl*)this->ToolBar2)->Brush->Bitmap=(bitmap);
 for (i=0; i<4; i++)
  MainMenu1->Items->Items[i]->OnDrawItem=FileNewItem->OnDrawItem;
 for(i=1;i<7;i++) {
  File1->Items[i]->OnMeasureItem=FileNewItem->OnMeasureItem;
  File1->Items[i]->OnDrawItem=FileNewItem->OnDrawItem;
 }
 for (i=0;i<3;i++) {
  Edit1->Items[i]->OnMeasureItem=FileNewItem->OnMeasureItem;
  Edit1->Items[i]->OnDrawItem=FileNewItem->OnDrawItem;
 }
 for(int i=0;i<5;i++) {
  Window1->Items[i]->OnMeasureItem=FileNewItem->OnMeasureItem;
  Window1->Items[i]->OnDrawItem=FileNewItem->OnDrawItem;
 }
 for(int i=0;i<1;i++) {
  Help1->Items[i]->OnMeasureItem=FileNewItem->OnMeasureItem;
  Help1->Items[i]->OnDrawItem=FileNewItem->OnDrawItem;
 }
 dt= new TCanvas();
 dc=GetWindowDC(this->Handle);
 dt->Handle=dc;
 dt->Brush->Color=clYellow;
 dt->Font->Color=clBlack;
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::ToolButton13Click(TObject *Sender) {
try {
 Current=((TMDIChild1*)(MainForm->ActiveMDIChild))->cur;
 TMDIChild1* Child1= ((TMDIChild1*)(MainForm->ActiveMDIChild));
 int i;
 TMDIChild* Child;
 for(i=0;i<MainForm->MDIChildCount;i++)
 if(MainForm->MDIChildren[i]->Name==AnsiString("MDIChild"))
  Child= ((TMDIChild*)(MainForm->MDIChildren[i]));
 TItemStates selected = TItemStates() <<isNone;
 Current1= ((TMDIChild*)(Child))->ListView1->GetNextItem(Current, sdBelow,selected);
 if( Current1!=NULL) {
  AnsiString str1=Child->DirectoryListBox1->Directory;
  AnsiString PictureName;
  if(Current1->Data==NULL)
   PictureName = Format("%s\\%s",ARRAYOFCONST((str1,Current1->Caption)));
  else
   PictureName = Format("%s\%s",ARRAYOFCONST(((PChar)(Current1->Data),Current1->Caption)));
  ((TMDIChild1*)(MainForm->ActiveMDIChild))->Caption=PictureName;
  try{
   ((TMDIChild1*)(MainForm->ActiveMDIChild))->Image1->Picture->LoadFromFile(PictureName);
  }
  catch(...) {
   ((TMDIChild1*)(MainForm->ActiveMDIChild))->Image1->Picture=NULL;
  }
 ((TMDIChild1*)(MainForm->ActiveMDIChild))->cur=Current1;
 }
 else ;
}catch (...) {;}
}

void __fastcall TMainForm::ToolButton12Click(TObject *Sender) {
try {
 int i; TMDIChild* Child;
 Current=((TMDIChild1*)(MainForm->ActiveMDIChild))->cur;
 TMDIChild1* Child1= ((TMDIChild1*)(MainForm->ActiveMDIChild));
 for(i=0;i<MainForm->MDIChildCount;i++)
  if(MainForm->MDIChildren[i]->Name==AnsiString("MDIChild"))
   Child= ((TMDIChild*)(MainForm->MDIChildren[i]));
 TItemStates selected = TItemStates() <<isNone;
 Current1= ((TMDIChild*)(Child))->ListView1->GetNextItem(Current, sdAbove,selected);
 if (Current1!=NULL) {
  AnsiString str1=Child->DirectoryListBox1->Directory;
  AnsiString PictureName;
  if(Current1->Data==NULL)
   PictureName = Format("%s\\%s",ARRAYOFCONST((str1,Current1->Caption)));
  else
   PictureName = Format("%s\\%s",ARRAYOFCONST(((PChar)(Current1->Data),Current1->Caption))); ((TMDIChild1*)(MainForm->ActiveMDIChild))->Caption=PictureName;
  try {
   ((TMDIChild1*)(MainForm->ActiveMDIChild))->Image1->Picture->LoadFromFile(PictureName);
  }
  catch(...) {
   ((TMDIChild1*)(MainForm->ActiveMDIChild))->Image1->Picture=NULL;
  }
  ((TMDIChild1*)(MainForm->ActiveMDIChild))->cur=Current1;
 }
 else  ;;
}catch(...){;}
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormDestroy(TObject *Sender) {
 bitmap->Free();
 bitmap1->Free();
 ReleaseDC(MainForm->Handle,dc);
 dt->Free();
 for (int i=0;i<MainForm->MDIChildCount-1;i++)
  MainForm->MDIChildren[i]->Free();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileNewItemDrawItem(TObject *Sender,
      TCanvas *ACanvas, TRect &ARect, bool Selected) {
 TReplaceFlags repl=TReplaceFlags()<< rfIgnoreCase;
 try {
  if (Selected) {
   ACanvas->Brush->Style=bsClear;
   ACanvas->StretchDraw(ARect,bitmap1);
   ACanvas->TextOutA(ARect.Left+2,ARect.Top+2,StringReplace(((TMenuItem*)(Sender))->Caption,"&","",repl));
  }
  else {
   ACanvas->Brush->Style=bsClear;
   ACanvas->StretchDraw(ARect,bitmap);
   ACanvas->TextOutA(ARect.Left+2,ARect.Top+2,StringReplace(((TMenuItem*)(Sender))->Caption,"&","",repl));
  }
 }
 catch(...){;}
 rct.Left=ARect.Left;
 rct.Top=ARect.Top;
 rct.Bottom=ARect.Bottom;
 rct.Right=ARect.Right;
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::FormPaint(TObject *Sender) {
 TRect r;
 r.Left=145;
 r.Top=27;
 r.Bottom=47;
 r.Right=Width-4;
}
//---------------------------------------------------------------------------





void __fastcall TMainForm::ToolButton8Click(TObject *Sender) {
 SearchDlg->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ToolButton16Click(TObject *Sender) {
 TMDIChild1* Child1=NULL;
 TMDIChild* Child=NULL;
 for(int i=0;i<MainForm->MDIChildCount;i++) {
  if(MainForm->MDIChildren[i]->Name==AnsiString("MDIChild1")) {
   Child1= ((TMDIChild1*)(MainForm->MDIChildren[i]));
  }
  if (MainForm->MDIChildren[i]->Name==AnsiString("MDIChild"))
   Child= ((TMDIChild*)(MainForm->MDIChildren[i]));
 }
 if (!SlideShow) {
  MainForm->ActiveMDIChild->WindowState=wsMaximized;
  if (Child1==NULL)
   ((TMDIChild*)(MainForm->ActiveMDIChild))->ListView1->OnDblClick(MainForm->ToolButton16);
  else {
   Child1->SetFocus();
  }
  Timer1->Enabled=true;///
 }
 SlideShow=true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Timer1Timer(TObject *Sender) {
 ToolButton13->Click();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ToolButton9Click(TObject *Sender) {
 Album->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::TabControl1Change(TObject *Sender) {
 if(TabControl1->TabIndex>0) {
  TMDIChild1* Child1;
  Child1=(TMDIChild1*)(MainForm->TabControl1->Tabs->Objects[MainForm->TabControl1->TabIndex]);
  Child1->SetFocus();
 }
 else {
  TMDIChild* Child;
  Child=(TMDIChild*)(MainForm->TabControl1->Tabs->Objects[0]);
  Child->Show();
 }
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::TabControl1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y) {
 TMDIChild1* Child1;
 int pos=0;
 for(int i=0;i<TabControl1->TabIndex;i++)
  pos+=(TabControl1->TabRect(i).Width());
 Child1=(TMDIChild1*)(MainForm->TabControl1->Tabs->Objects[MainForm->TabControl1->TabIndex]);
 TRect rect=TabControl1->TabRect(MainForm->TabControl1->TabIndex);
 if((X>rect.Width()-18+pos&&X<rect.Width()-5+pos&&Y>rect.Top&&Y<rect.Bottom)) {
  Child1->Close();
 }
}
//---------------------------------------------------------------------------




void __fastcall TMainForm::TabControl1DrawTab(TCustomTabControl *Control,
      int TabIndex, const TRect &Rect, bool Active) {
 TabControl1->Canvas->Refresh();
 int pos=0;
 for(int i=0;i<TabControl1->TabIndex;i++)
  pos+=(TabControl1->TabRect(i).Width());
 if(Active){
  TabControl1->Canvas->StretchDraw(Rect,bitmap);
  TabControl1->Canvas->Brush->Style=bsClear;
  TabControl1->Canvas->TextOutA(Rect.Left+3,Rect.Top+3,MainForm->TabControl1->Tabs->Strings[TabIndex]);
 }
 else {
  TabControl1->Canvas->StretchDraw(Rect,bitmap);
  TabControl1->Canvas->Brush->Style=bsClear;
  TabControl1->Canvas->TextOutA(Rect.Left,Rect.Top+3,MainForm->TabControl1->Tabs->Strings[TabIndex]);
 }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::N2Click(TObject *Sender) {
 ShellExecute(Handle,"open",(ExtractFilePath(Application->ExeName)+"Readme.txt").c_str(),NULL,NULL,SW_SHOWDEFAULT);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ToolButton3Click(TObject *Sender) {
 //extern TAlbum *Album;
 //Album->BitBtn1Click(this);
 ShowMessage ("   ...");
}
//---------------------------------------------------------------------------

