//----------------------------------------------------------------------------
#ifndef MainH
#define MainH
//----------------------------------------------------------------------------
#include "ChildWin.h"
#include "ChildWin1.h"
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Messages.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Menus.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <StdActns.hpp>
#include <ToolWin.hpp>
#include <Tabs.hpp>

//----------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
	TMainMenu *MainMenu1;
	TMenuItem *File1;
	TMenuItem *FileNewItem;
	TMenuItem *FileOpenItem;
	TMenuItem *FileCloseItem;
	TMenuItem *Window1;
	TMenuItem *Help1;
	TMenuItem *N1;
	TMenuItem *FileExitItem;
	TMenuItem *WindowCascadeItem;
	TMenuItem *WindowTileItem;
	TMenuItem *WindowArrangeItem;
	TMenuItem *HelpAboutItem;
	TOpenDialog *OpenDialog;
	TMenuItem *FileSaveItem;
	TMenuItem *FileSaveAsItem;
	TMenuItem *Edit1;
	TMenuItem *CutItem;
	TMenuItem *CopyItem;
	TMenuItem *PasteItem;
	TMenuItem *WindowMinimizeItem;
        TStatusBar *StatusBar;
        TActionList *ActionList1;
        TEditCut *EditCut1;
        TEditCopy *EditCopy1;
        TEditPaste *EditPaste1;
        TAction *FileNew1;
        TAction *FileSave1;
        TAction *FileExit1;
        TAction *FileOpen1;
        TAction *FileSaveAs1;
        TWindowCascade *WindowCascade1;
        TWindowTileHorizontal *WindowTileHorizontal1;
        TWindowArrange *WindowArrangeAll1;
        TWindowMinimizeAll *WindowMinimizeAll1;
        TAction *HelpAbout1;
        TWindowClose *FileClose1;
        TWindowTileVertical *WindowTileVertical1;
        TMenuItem *WindowTileItem2;
        TToolBar *ToolBar2;
        TToolButton *ToolButton4;
        TToolButton *ToolButton5;
        TToolButton *ToolButton6;
        TToolButton *ToolButton7;
        TImageList *ImageList1;
        TToolBar *ToolBar1;
        TToolButton *ToolButton12;
        TToolButton *ToolButton13;
        TImageList *ImageList2;
        TToolButton *ToolButton1;
        TToolButton *ToolButton2;
        TToolButton *ToolButton3;
        TToolButton *ToolButton9;
        TImageList *ImageList3;
        TToolButton *ToolButton8;
        TToolButton *ToolButton10;
        TToolButton *ToolButton11;
        TToolButton *ToolButton14;
        TToolButton *ToolButton15;
        TToolButton *ToolButton16;
        TTimer *Timer1;
        TTabControl *TabControl1;
        TMenuItem *N2;
        void __fastcall FileNew1Execute(TObject *Sender);
        void __fastcall FileOpen1Execute(TObject *Sender);
        void __fastcall HelpAbout1Execute(TObject *Sender);
        void __fastcall FileExit1Execute(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall ToolButton13Click(TObject *Sender);
        void __fastcall ToolButton12Click(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall FileNewItemDrawItem(TObject *Sender,
          TCanvas *ACanvas, TRect &ARect, bool Selected);
        void __fastcall FormPaint(TObject *Sender);
        void __fastcall ToolButton8Click(TObject *Sender);
        void __fastcall ToolButton16Click(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall ToolButton9Click(TObject *Sender);
        void __fastcall TabControl1Change(TObject *Sender);
        void __fastcall TabControl1MouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall TabControl1DrawTab(TCustomTabControl *Control,
          int TabIndex, const TRect &Rect, bool Active);
        void __fastcall N2Click(TObject *Sender);
        void __fastcall ToolButton3Click(TObject *Sender);
        
          private:
	TMDIChild*  __fastcall CreateMDIChild(const String Name);
       // void __fastcall CreateMDIChild1(const String Name);

public:

	virtual __fastcall TMainForm(TComponent *Owner);
        TMDIChild1* __fastcall CreateMDIChild1(const String Name,TListItem* curr);
        TListItem *Current,*Current1;
protected:
void __fastcall ProcessMenu(TMessage &Message);

//BEGIN_MESSAGE_MAP

//  MESSAGE_HANDLER(WM_COMMAND, TMessage, ProcessMenu)
//END_MESSAGE_MAP(TForm)

   };
//----------------------------------------------------------------------------
extern TMainForm *MainForm;
//extern TMDIChild *__fastcall MDIChildCreate(void);
extern TMDIChild1 *__fastcall MDIChildCreate1(void);
//----------------------------------------------------------------------------
#endif    
