//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "search.h"
#include "childwin.h"
#include "main.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSearchDlg *SearchDlg;    TMDIChild* Child;
//---------------------------------------------------------------------------
__fastcall TSearchDlg::TSearchDlg(TComponent* Owner)
        : TForm(Owner) {
}
//---------------------------------------------------------------------------
void __fastcall TSearchDlg::Button2Click(TObject *Sender) {
 this->Close();
}
//---------------------------------------------------------------------------
void __fastcall TSearchDlg::Button1Click(TObject *Sender) {
 AnsiString name,path,Class,Rating;
 ((TMDIChild*)(Child))->ListView1->Clear();
 ((TMDIChild*)(Child))->ImageList1->Clear();
 ((TMDIChild*)(Child))->ImageList2->Clear();
 ((TMDIChild*)(Child))->ADOQuery5->Open();
 ((TMDIChild*)(Child))->ADOQuery5->First();
 if(Child->ADOQuery5->RecordCount>0) while(!Child->ADOQuery5->Eof) {
  name=Child->ADOQuery5->FieldByName("FULLNAME")->AsString;
  Class=Child->ADOQuery5->FieldByName("CLASS")->AsString;
  Rating=Child->ADOQuery5->FieldByName("RATING")->AsString;
  path=ExtractFilePath(name);
  int l1= path.Length()+1;
  PChar s1=new Char[l1];
  strcpy(s1,path.c_str());
  Child->ListView1->AddItem(ExtractFileName(name),(TObject*)s1);
  DWORD filesize;
  HANDLE hFile=
  CreateFile(
    name.c_str(),	// pointer to name of the file
    GENERIC_READ	,	// access (read-write) mode
    FILE_SHARE_READ	,	// share mode
    NULL,	// pointer to security attributes
    OPEN_EXISTING	,	// how to create
    0,	// file attributes
    NULL 	// handle to file with attributes to copy
   );
  filesize=GetFileSize(hFile,NULL);
  CloseHandle(hFile);
  Child->ListView1->Items->Item[Child->ListView1->Items->Count-1]->SubItems->Add(IntToStr(filesize));
  Child->ListView1->Items->Item[Child->ListView1->Items->Count-1]->SubItems->Add(Class);
  Child->ListView1->Items->Item[Child->ListView1->Items->Count-1]->SubItems->Add(Rating);
  Child->ADOQuery5->Next();
 }
 Child->ADOQuery5->Close();
}
//---------------------------------------------------------------------------

void __fastcall TSearchDlg::ComboBox1Change(TObject *Sender) {
 if(ComboBox1->Text=="") {
  ((TMDIChild*)(Child))->ADOQuery5->SQL->Strings[1]="and RATING=(:rating)";
  ((TMDIChild*)(Child))->ADOQuery5->Parameters->ParamByName("rating")->Value =0;
 }
 else if (ComboBox1->Text=="") {
  ((TMDIChild*)(Child))->ADOQuery5->SQL->Strings[1]="";
 }
 else {
  ((TMDIChild*)(Child))->ADOQuery5->SQL->Strings[1]="and RATING=(:rating)";
  ((TMDIChild*)(Child))->ADOQuery5->Parameters->ParamByName("rating")->Value =ComboBox1->Text.ToInt();
 }
}
//---------------------------------------------------------------------------

void __fastcall TSearchDlg::ComboBox2Change(TObject *Sender) {
 if(ComboBox2->Text=="") {
  ((TMDIChild*)(Child))->ADOQuery5->SQL->Strings[2]="and CLASS=(:class)";
  ((TMDIChild*)(Child))->ADOQuery5->Parameters->ParamByName("class")->Value ="";
 }
 else if (ComboBox2->Text=="") {
  ((TMDIChild*)(Child))->ADOQuery5->SQL->Strings[2]="";
 }
 else {
  ((TMDIChild*)(Child))->ADOQuery5->SQL->Strings[2]="and CLASS=(:class)";
  ((TMDIChild*)(Child))->ADOQuery5->Parameters->ParamByName("class")->Value =ComboBox2->Text.Trim();
 }
}
//---------------------------------------------------------------------------


void __fastcall TSearchDlg::FormShow(TObject *Sender) {
 for(int i=0;i<MainForm->MDIChildCount;i++)
  if(MainForm->MDIChildren[i]->Name==AnsiString("MDIChild"))
   Child= ((TMDIChild*)(MainForm->MDIChildren[i]));
}
//---------------------------------------------------------------------------

void __fastcall TSearchDlg::Edit1Exit(TObject *Sender) {
 AnsiString name,path,Class,Rating;
 ((TMDIChild*)(Child))->ADOQuery5->Close();
 ((TMDIChild*)(Child))->ADOQuery5->SQL->Strings[0]=("SELECT * from Images WHERE FULLNAME LIKE (:name1)");
 ((TMDIChild*)(Child))->ADOQuery5->Parameters->ParamByName("name1")->Value =("%"+Edit1->Text+"%") ;
}
//---------------------------------------------------------------------------

