//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Albums.h"
#include "ChildWin.h"
#include "Main.h"
#include "Windows.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TAlbum *Album;
TMDIChild* Child;
//---------------------------------------------------------------------------
__fastcall TAlbum::TAlbum(TComponent* Owner)
        : TForm(Owner) {
}
//---------------------------------------------------------------------------
void __fastcall TAlbum::InsertInAlbum(AnsiString Alb,AnsiString Pic) {
 ADOQuery4->Parameters->CreateParameter("name1",ftString,pdInputOutput,0,"OleStr");
 ADOQuery4->SQL->Clear();
 ADOQuery4->SQL->Add("INSERT INTO Link");
 ADOQuery4->SQL->Add("(Cod,AlbumNum)");
 ADOQuery4->SQL->Add("select Cod,AlbumNum from Images,Albums where Fullname =(:name1) and AlbumName=(:aname);");
 ADOQuery4->Parameters->ParamByName("name1")->Value=Pic;
 ADOQuery4->Parameters->ParamByName("aname")->Value=Alb;
 ShowMessage(Pic+"  "+Alb);
 try {
  ADOQuery4->ExecSQL();
 }
 catch(...) {
  ShowMessage("  "+ExtractFileName(Pic)+"     ");
 }
}
//////////////////

void __fastcall TAlbum::DBLookupListBox1Click(TObject *Sender) {
 ADOQuery1->Close();
 ADOQuery1->Parameters->ParamByName("aname")->Value =DBLookupListBox1->SelectedItem;
 ADOQuery1->Open();
 ListBox1->Clear();
 while(!ADOQuery1->Eof) {
  ListBox1->Items->AddObject(ADOQuery1->FieldByName("Fullname")->Value,NULL);
  ADOQuery1->Next();
 }
}
//---------------------------------------------------------------------------

void __fastcall TAlbum::SpeedButton6Click(TObject *Sender) {
 int sel,i;
 ADOQuery3->SQL->Clear();
 ADOQuery3->SQL->Add("DELETE * From Link");
 ADOQuery3->SQL->Add("where Cod=(select Cod from Images");
 ADOQuery3->SQL->Add("where Fullname=(:name1))");
 ADOQuery3->SQL->Add("and");
 ADOQuery3->SQL->Add(" AlbumNum=(select AlbumNum from Albums");
 ADOQuery3->SQL->Add("where AlbumName=(:aname));");
 for(i=0;i<ListBox1->Items->Count;i++)
  if(ListBox1->Selected[i]) {
   ADOQuery3->Parameters->ParamByName("name1")->Value=ListBox1->Items->Strings[i];
   ADOQuery3->Parameters->ParamByName("aname")->Value=DBLookupListBox1->SelectedItem;
   break;
  }
 if(MessageBox(Handle,"   ?","",MB_OKCANCEL+MB_ICONQUESTION)==IDOK) {
  ADOQuery3->ExecSQL();
  ListBox1->Items->Delete(i);
 }
}
//---------------------------------------------------------------------------
 char szItemName[100];
 bool err;
 BOOL CALLBACK DialogProc(
    HWND hwndDlg,	// handle to dialog box
    UINT uMsg,	// message
    WPARAM wParam,	// first message parameter
    LPARAM lParam 	// second message parameter
 )
 {
    switch (uMsg) {
    case WM_SHOWWINDOW:
      SetWindowText(hwndDlg,"/");
      break;
        case WM_COMMAND:
            switch (LOWORD(wParam)) {
                case 1:
                EndDialog(hwndDlg, wParam);
                    if (!GetDlgItemText(hwndDlg, 101,szItemName, 80)||szItemName=="")
                          {
                         *szItemName=0;
                         err=true;
                         return false;
                         }else
                         {
                         err=false;
                         return true;
                         }
                case 2:
                    err=false;
                    EndDialog(hwndDlg, wParam);
                    return false;
            }
    }
    return false;
   }

void __fastcall TAlbum::SpeedButton1Click(TObject *Sender) {
 TMenuItem* item;
 int rez=DialogBox(HInstance,"DIALOG_1",Album->Handle,(DLGPROC)DialogProc) ;
 if(rez!=2&&!err) {
  ADOQuery4->SQL->Clear();
  ADOQuery4->SQL->Add("INSERT INTO Albums");
  ADOQuery4->SQL->Add("(AlbumName) VALUES");
  ADOQuery4->SQL->Add("(");
  ADOQuery4->SQL->Add("(:aname)");
  ADOQuery4->SQL->Add(");");
  ADOQuery4->Parameters->ParamByName("aname")->Value=szItemName;
  ADOQuery4->ExecSQL();
  Child->CheckListBox1->Items->Add(szItemName);
  item=new  TMenuItem(Child->N43);
  Child->N43->Add(item);
  Child->N43->Items[Child->N43->Count-1]->OnClick=Child->AllClick;
  Child->N43->Items[Child->N43->Count-1]->Caption=szItemName;
  ADOQuery2->Close();
  ADOQuery2->Open();
 }
}
//---------------------------------------------------------------------------

void __fastcall TAlbum::SpeedButton3Click(TObject *Sender) {
 int sel,i;
 if(MessageBox(Handle,"   ?","",MB_OKCANCEL+MB_ICONQUESTION)==IDOK) {
  ADOQuery3->Parameters->CreateParameter("aname",ftString,pdInputOutput,0,"OleStr");
  ADOQuery3->SQL->Clear();
  ADOQuery3->SQL->Add("DELETE * From Link");
  ADOQuery3->SQL->Add("where AlbumNum=(select AlbumNum from Albums where AlbumName=(:aname));");
  ADOQuery3->Parameters->ParamByName("aname")->Value=DBLookupListBox1->SelectedItem;
  ADOQuery3->ExecSQL();
  ADOQuery3->SQL->Clear();
  ADOQuery3->SQL->Add("DELETE * From Albums");
  ADOQuery3->SQL->Add("where AlbumName=(:aname);");
  ADOQuery3->Parameters->ParamByName("aname")->Value=DBLookupListBox1->SelectedItem;
  TMenuItem* item;AnsiString ListItem; int pos;
  item=Child->N43->Find(DBLookupListBox1->SelectedItem);
  Child->N43->Delete(Child->N43->IndexOf(item)) ;
  pos=Child->CheckListBox1->Items->IndexOf(DBLookupListBox1->SelectedItem);
  Child->CheckListBox1->Items->Delete(pos);
  ADOQuery3->ExecSQL();
  ADOQuery2->Close();
  ADOQuery2->Open();
 }
}
//---------------------------------------------------------------------------

void __fastcall TAlbum::ADOQuery4EditError(TDataSet *DataSet,
      EDatabaseError *E, TDataAction &Action) {
 ShowMessage("");
 Action= daFail;
}
//---------------------------------------------------------------------------

void __fastcall TAlbum::SpeedButton2Click(TObject *Sender) {
 AnsiString OldName=DBLookupListBox1->SelectedItem;
 int rez=DialogBox(HInstance,"DIALOG_1",Album->Handle,(DLGPROC)DialogProc) ;
 if(rez!=2&&!err) {
  ADOQuery4->Parameters->CreateParameter("aname1",ftString,pdInputOutput,0,"OleStr");
  ADOQuery4->SQL->Clear();
  ADOQuery4->SQL->Add("UPDATE Albums");
  ADOQuery4->SQL->Add("SET AlbumName=(:aname)");
  ADOQuery4->SQL->Add("WHERE AlbumName=(:aname1)");
  ADOQuery4->Parameters->ParamByName("aname1")->Value=OldName;
  ADOQuery4->Parameters->ParamByName("aname")->Value=szItemName;
  try {
   ADOQuery4->ExecSQL();
   Child->CheckListBox1->Items->Strings[ADOQuery2->RecNo-1]=szItemName;
   Child->N43->Items[Child->N43->Count-2]->Caption=szItemName;
  }
  catch(...) { }
  ADOQuery2->Close();
  ADOQuery2->Open();
 }
}
//---------------------------------------------------------------------------

void __fastcall TAlbum::FormShow(TObject *Sender) {
 for(int i=0;i<MainForm->MDIChildCount;i++)
  if(MainForm->MDIChildren[i]->Name==AnsiString("MDIChild"))
   Child= ((TMDIChild*)(MainForm->MDIChildren[i]));
}
//---------------------------------------------------------------------------



void __fastcall TAlbum::BitBtn1Click(TObject *Sender) {
 ADOQuery1->Close();
 ADOQuery1->Parameters->ParamByName("aname")->Value =DBLookupListBox1->SelectedItem;
 ADOQuery1->Open();
 TStringList* html; AnsiString str;
 html= new TStringList();
 DataSetPageProducer1->HTMLDoc->Clear();
 DataSetPageProducer1->HTMLDoc->LoadFromFile(ExtractFilePath(Application->ExeName)+"Template.htm");
 for(int i=0;i<ADOQuery1->RecordCount;i++) {
  if (i<ADOQuery1->RecordCount)
   DataSetPageProducer1->HTMLDoc->Insert(31+i,"['', '<#fullname>', '', '', ''],");
  else
   DataSetPageProducer1->HTMLDoc->Insert(31+i,"['', '<#fullname>', '', '', '']");
 }
 str=DataSetPageProducer1->Content();
 html->Add(str);
 SaveDialog1->FileName=DBLookupListBox1->SelectedItem;
 if(SaveDialog1->Execute())
 try {
  html->SaveToFile(SaveDialog1->FileName);
  if(CheckBox1->Checked)
   ShellExecute(Handle,"open",SaveDialog1->FileName.c_str(),NULL,NULL,SW_SHOWDEFAULT);
 }
 catch(...) { }
 html->Free();
}
//---------------------------------------------------------------------------

void __fastcall TAlbum::DataSetPageProducer1HTMLTag(TObject *Sender,
      TTag Tag, const AnsiString TagString, TStrings *TagParams,
      AnsiString &ReplaceText) {
 int ImageID;
 switch (Tag)  {
  case tgCustom:  {
   TReplaceFlags repl=TReplaceFlags()<< rfIgnoreCase <<rfReplaceAll;
   ReplaceText = StringReplace(AnsiString("file://localhost/") +
    ADOQuery1->FieldByName("Fullname")->AsString + AnsiString(""),"\\","\/",repl);
   if(TagParams->Text=="" )
    ADOQuery1->Next();
  }
  break;
 }
}
//---------------------------------------------------------------------------


