//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ChildWin.h"
#include "ChildWin1.h"
#include "main.h"
#include "Albums.h"
#include "search.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
extern bool SlideShow;

//---------------------------------------------------------------------
__fastcall TMDIChild::TMDIChild(TComponent *Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------
void __fastcall TMDIChild::FormClose(TObject *Sender, TCloseAction &Action)
{
 Action = caNone;
}
//---------------------------------------------------------------------
TMDIChild1* __fastcall TMDIChild::CreateMDIChild1(AnsiString Name,TListItem* curr) {
 TMDIChild1 *Child;
 //--- create a new MDI child window ----
 Child = new TMDIChild1(Application);
 Child->Caption = Name;
 Child->cur=curr;
 try {
  Child->Image1->Picture->LoadFromFile(Name);
 }
 catch(...) {
  Child->Image1->Picture=NULL;
 }
 ((TMainForm*)(Application->MainForm))->ToolBar2->Visible=false;
 ((TMainForm*)(Application->MainForm))->ToolBar1->Visible=true;
 return Child;
}
///////////////////////////////////////////

void TMDIChild::SelectByRating(int rating) {
 ListView1->SetFocus();
 for (int i=0;i<ListView1->Items->Count;i++) {
  if (ListView1->Items->Item[i]->Selected&&ListView1->Items->Item[i]->SubItems->Strings[2]!=(rating))
   ListView1->Items->Item[i]->Selected=false;
  if(rating>0) {
   if(ListView1->Items->Item[i]->SubItems->Strings[2]==(rating)) {
    ListView1->Items->Item[i]->Selected=true;
   }
  }
  else if (ListView1->Items->Item[i]->SubItems->Strings[2]==AnsiString("")||ListView1->Items->Item[i]->SubItems->Strings[2]=="0") {
   ListView1->Items->Item[i]->Selected=true;
  }
 }
}

void __fastcall TMDIChild::AllClick(TObject *Sender) {
 TListItem *Item=ListView1->Selected; TReplaceFlags repl=TReplaceFlags()<< rfIgnoreCase;
 TItemStates selected = TItemStates() << isSelected;
 while(Item!=NULL) {
  int code;
  AnsiString str;
  AnsiString str1=DirectoryListBox1->Directory;
  if (Item->Data!=NULL)
   str = Format("%s\%s",ARRAYOFCONST(((PChar)(Item->Data),Item->Caption)));
  else {
   if (str1.Length()>3)
    str = Format("%s\\%s",ARRAYOFCONST((str1,Item->Caption)));
   else {
    AnsiString drive=AnsiString(DriveComboBox1->Drive).UpperCase();
    str = Format("%s:\\%s",ARRAYOFCONST((drive,Item->Caption)));
   }
  }
  if (Item->SubItems->Strings[2]==AnsiString("")||Item->SubItems->Strings[1]==AnsiString("")) {
   ADOTable1->Open();
   code=ADOTable1->FieldByName("LastAdded")->AsInteger;
   code++;
   ADOQuery3->Parameters->ParamByName("cod")->Value=code;
   ADOQuery3->Parameters->ParamByName("name1")->Value=str;
   ADOQuery3->Parameters->ParamByName("rating")->Value=Variant("0");
   ADOQuery3->Parameters->ParamByName("class")->Value=Variant("");
   ADOQuery3->ExecSQL();
   Item->SubItems->Strings[1]="";
   ADOTable1->First();
   ADOTable1->Edit();
   ADOTable1->FieldByName("LastAdded")->AsInteger=code;
   ADOTable1->Post();
   ADOTable1->Close();
  }
  Album->InsertInAlbum(StringReplace(((TMenuItem*)(Sender))->Caption,"&","",repl),str);
  Item= ListView1->GetNextItem(Item, sdAll,selected);
 }
}

/////////////////////////////////////////////
void TMDIChild::SetTag(AnsiString tag) {
 AnsiString str1=DirectoryListBox1->Directory;
 AnsiString str;
 TListItem *Item=ListView1->Selected;
 int code;
 while(Item!=NULL) {
  TItemStates selected = TItemStates() << isSelected;
  if(Item->Data!=NULL)
   str = Format("%s\%s",ARRAYOFCONST(((PChar)(Item->Data),Item->Caption)));
  else
   str = Format("%s\\%s",ARRAYOFCONST((str1,Item->Caption)));
  if(Item->SubItems->Strings[2]==""&&Item->SubItems->Strings[1]=="") {
   ADOTable1->Open();
   ADOTable1->First();
   code=ADOTable1->FieldByName("LastAdded")->AsInteger;
   code++;
   ADOQuery3->Parameters->ParamByName("cod")->Value=code;
   ADOQuery3->Parameters->ParamByName("name1")->Value=str;
   ADOQuery3->Parameters->ParamByName("rating")->Value=0;
   ADOQuery3->Parameters->ParamByName("class")->Value=tag;
   ADOQuery3->ExecSQL();
   Item->SubItems->Strings[1]=tag;
   ADOTable1->First();
   ADOTable1->Edit();
   ADOTable1->FieldByName("LastAdded")->AsInteger=code;
   ADOTable1->Post();
   ADOTable1->Close();
  }
  else {
   ADOQuery2->SQL->Clear();
   ADOQuery2->SQL->Add("UPDATE Images");
   ADOQuery2->SQL->Add("SET CLASS=(:class)");
   ADOQuery2->SQL->Add("WHERE FULLNAME=(:name1);");
   ADOQuery2->Parameters->ParamByName("name1")->Value=str;
   ADOQuery2->Parameters->ParamByName("class")->Value=tag ;
   ADOQuery2->ExecSQL();
   Item->SubItems->Strings[1]=tag;
  }
  Item= ListView1->GetNextItem(Item, sdAll,selected);
 }
}
////////////////////
void TMDIChild::SetRating(int rating) {
 AnsiString str1=DirectoryListBox1->Directory;
 AnsiString   str;
 TListItem *Item=ListView1->Selected;
 int code;
 while(Item!=NULL) {
  TItemStates selected = TItemStates() << isSelected;
  if(Item->Data!=NULL)
   str = Format("%s\%s",ARRAYOFCONST(((PChar)(Item->Data),Item->Caption)));
  else
   str = Format("%s\\%s",ARRAYOFCONST((str1,Item->Caption)));
  if(Item->SubItems->Strings[2]==""&&Item->SubItems->Strings[1]=="") {
   ADOTable1->Open();
   ADOTable1->First();
   code=ADOTable1->FieldByName("LastAdded")->AsInteger;
   code++;
   ADOQuery3->Parameters->ParamByName("cod")->Value=code;
   ADOQuery3->Parameters->ParamByName("name1")->Value=str;
   ADOQuery3->Parameters->ParamByName("rating")->Value=rating;
   ADOQuery3->Parameters->ParamByName("class")->Value="0";
   ADOQuery3->ExecSQL();
   Item->SubItems->Strings[2]=rating;
   ADOTable1->First();
   ADOTable1->Edit();
   ADOTable1->FieldByName("LastAdded")->AsInteger=code;
   ADOTable1->Post();
   ADOTable1->Close();
  }
  else {
   ADOQuery2->SQL->Clear();
   ADOQuery2->SQL->Add("UPDATE Images");
   ADOQuery2->SQL->Add("SET RATING=(:rating)");
   ADOQuery2->SQL->Add("WHERE FULLNAME=(:name1);");
   ADOQuery2->Parameters->ParamByName("name1")->Value=str;
   ADOQuery2->Parameters->ParamByName("rating")->Value=rating ;
   ADOQuery2->ExecSQL();
   Item->SubItems->Strings[2]=IntToStr(rating);
  }
  Item= ListView1->GetNextItem(Item, sdAll,selected);
 }
}

void __fastcall TMDIChild::DirectoryListBox1Change(TObject *Sender) {
  ListView1->ClearSelection();
  ListView1->Items->Clear();
  Image1->Picture=NULL;
  TSearchRec sr;
  int iAttributes = 0;
 //StringGrid1->ColCount = 3;
 //iAttributes |= faReadOnly * CheckBox1->Checked;
 //iAttributes |= faHidden * CheckBox2->Checked;
 //iAttributes |= faSysFile * CheckBox3->Checked;
 //iAttributes |= faVolumeID * CheckBox4->Checked;
 //iAttributes |= faDirectory * CheckBox5->Checked;
 //iAttributes |= faArchive * CheckBox6->Checked;
 //iAttributes |= faAnyFile * CheckBox7->Checked;
 //StringGrid1->RowCount = 1;
  AnsiString exts[6]={
   "\\*.jpg",
   "\\*.wmf",
   "\\*.ico",
   "\\*.bmp",
   "\\*.emf",
   "\\*.png"
  };
  AnsiString str,str1;    int last=0; int index_=0;
  str1=(((TDirectoryListBox*)Sender)->Directory);
  Edit1->Text=str1;
  ImageList1->Clear();
  ImageList2->Clear();
  ADOQuery1->Close();
  ADOQuery1->SQL->Clear();
  ADOQuery1->SQL->Add("SELECT * from Images WHERE FULLNAME LIKE (:name1);");
  ADOQuery1->Parameters->ParamByName("name1")->Value ="%"+Variant(str1)+"%" ;
  ADOQuery1->Open();
  for(int i=0;i<6;i++) {
   if (FindFirst(str1+exts[i], iAttributes, sr) == 0) {
    do {
     Word index=0 ;
     if(str1.Length()>3)
      str = Format("%s\\%s",ARRAYOFCONST((str1,sr.Name)));
     else
      str = Format("%s:\\%s",ARRAYOFCONST((DriveComboBox1->Drive,sr.Name)));
     HICON ic=ExtractAssociatedIcon(HInstance,str.c_str(),&index);
     TIcon *icn=new TIcon();
     icn->Handle=ic;
     if(ic!=NULL) {
      ImageList1->AddIcon(icn);
      ImageList2->AddIcon(icn);
     }
     icn->Free();
     ListView1->AddItem(sr.Name,NULL);
     ListView1->Items->Item[last]->SubItems->Add(IntToStr(sr.Size));
     ListView1->Items->Item[last]->SubItems->Add("");
     ListView1->Items->Item[last]->SubItems->Add("");
     TLocateOptions Opts;
     Opts.Clear();
     Opts << loPartialKey;
     Variant locvalues[1];
     locvalues[0] = Variant(str);
     bool found=ADOQuery1->Locate("Fullname", locvalues[0] , Opts);
     if(found) {
      ListView1->Items->Item[last]->SubItems->Strings[1]=ADOQuery1->FieldByName("CLASS")->AsString;
      ListView1->Items->Item[last]->SubItems->Strings[2]=ADOQuery1->FieldByName("RATING")->AsInteger;
     }
     ListView1->Items->Item[last]->ImageIndex=index_;
     last++;
     index_++;
    } while (FindNext(sr) == 0);
    FindClose(sr);
   }
  }
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::Splitter1Moved(TObject *Sender) {
 Image1->Top=Splitter1->Top+Splitter1->Height;
 Image1->Height=Panel1->Height-(ListView1->Height+Splitter1->Height)-2;;
}
//---------------------------------------------------------------------------
 MENUITEMINFO info1;
void __fastcall TMDIChild::FormShow(TObject *Sender) {
 AnsiString Path=ExcludeTrailingBackslash(ExtractFilePath(Application->ExeName)+"\\db");
 ADOConnection1->ConnectionString=Format("Provider=MSDASQL;Persist Security Info=False;Mode=ReadWrite;Extended Properties='CollatingSequence=ASCII;DefaultDir=%s;Driver={Microsoft Paradox Driver (*.db )};DriverId=538;FIL=Paradox 5.X;FILEDSN=%s\\attr.dsn;MaxBufferSize=2048;MaxScanRows=8;PageTimeout=5;ParadoxNetPath=C:\\WINDOWS\\system32;ParadoxNetStyle=4.x;ParadoxUserName=admin;SafeTransactions=0;Threads=3;UID=admin;UserCommitSync=Yes;';Initial Catalog=%s",ARRAYOFCONST((Path,Path,Path)));
 ADOConnection1->DefaultDatabase=Path;
 ADOConnection1->Connected=true;
 ADOQuery1->Connection=ADOConnection1;
 ADOQuery2->Connection=ADOConnection1;
 ADOQuery3->Connection=ADOConnection1;
 ADOQuery4->Connection=ADOConnection1;
 ADOQuery5->Connection=ADOConnection1;
 ADOTable1->Connection=ADOConnection1;
 ADOTable1->TableName="LastAdded";
 DirectoryListBox1->OnChange(DirectoryListBox1);
 Panel2->Height=this->ClientHeight-ToolBar2->Height-90;
 PageControl1->Height=Panel2->Height;
 DirectoryListBox1->Height=PageControl1->Height-ToolBar2->Height+1;
 CheckListBox1->Height=PageControl1->Height-ToolBar2->Height;
 Panel1->Left=Panel2->Left+Panel2->Width+Splitter2->Width-2;
 Panel1->Width=Width-(Panel2->Left+Panel2->Width+Splitter2->Width)-2;
 Panel1->Height=this->ClientHeight-(Panel1->Top)+ToolBar2->Height-23;
 Image1->Height=Panel1->Height-(ListView1->Height+Splitter1->Height)-2;
 PopupMenu1->Items->Insert(4,PopupMenu2->Items);
 PopupMenu1->Items->Items[4]->Caption=AnsiString("");
 PopupMenu1->Items->InsertNewLineAfter(PopupMenu1->Items->Items[4]);

 TMDIChild* Chld;
 TMenuItem *item;
 Album->ADOQuery2->Connection=  ADOConnection1;;
 Album->ADOQuery2->Open();
 Album->ADOQuery2->First();
 CheckListBox1->Items->Clear();
 if(N43->Count==0)
 while(!Album->ADOQuery2->Eof) {
  item=new  TMenuItem(N43);
  N43->Add(item);
  CheckListBox1->Items->Add(Album->ADOQuery2->FieldByName("AlbumName")->AsString);
  N43->Items[N43->Count-1]->OnClick=AllClick;
  N43->Items[N43->Count-1]->Caption=Album->ADOQuery2->FieldByName("AlbumName")->AsString;
  N43->Items[N43->Count-1]->ShortCut=-1;
  Album->ADOQuery2->Next();
 }
 Album->ADOQuery2->First();
 ADOQuery5->SQL->Strings[1]="";
 ADOQuery5->SQL->Strings[2]="";
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::ListView1ContextPopup(TObject *Sender,
 TPoint &MousePos, bool &Handled) {
 if (ListView1->Items->Count>0&&ListView1->ItemFocused!=NULL)  {
  TRect Rect;
  Rect=ListView1->ItemFocused->DisplayRect(drBounds);
  int x1=Mouse->CursorPos.x;
  int y1=Mouse->CursorPos.y;
  if (MousePos.x>Rect.Left&&MousePos.x<Rect.Left+Rect.Width()&&MousePos.y>Rect.Top&&MousePos.y<Rect.Top+Rect.Height()) {
   PopupMenu1->Popup(x1,y1);
  }
 }
}
//---------------------------------------------------------------------------
void __fastcall TMDIChild::N8Click(TObject *Sender) {
 SetRating(0);
}

void __fastcall TMDIChild::N3Click(TObject *Sender)
{
 SetRating(1);
}
//---------------------------------------------------------------------------
void __fastcall TMDIChild::N4Click(TObject *Sender)
{
 SetRating(2);
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::N5Click(TObject *Sender)
{
 SetRating(3);
}

//---------------------------------------------------------------------------
void __fastcall TMDIChild::N6Click(TObject *Sender)
{
SetRating(4);
}


//---------------------------------------------------------------------------

void __fastcall TMDIChild::N7Click(TObject *Sender)
{
SetRating(5);
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::ListView1Click(TObject *Sender) {
 AnsiString str;
 if (ListView1->Selected!=NULL){
  str=DirectoryListBox1->Directory;
  if(ListView1->Selected->Data==NULL) {
   str = Format("%s\\%s",ARRAYOFCONST((str,ListView1->Selected->Caption)));
  }
  else {
   Edit1->Text=ExcludeTrailingBackslash(PChar((ListView1->Selected->Data)));
   str = Format("%s\\%s",ARRAYOFCONST((Edit1->Text,ListView1->Selected->Caption)));
  }
  try {
   Image1->Picture->LoadFromFile(str);
  }
  catch(...) {
   Image1->Picture=NULL;
  }
 }
 ((TMainForm*)(Application->MainForm))->Current=ListView1->Selected;
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::N9Click(TObject *Sender) {
 SetTag(((TMenuItem*)Sender)->Caption);
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::N3D1Click(TObject *Sender) {
 TReplaceFlags repl=TReplaceFlags()<< rfIgnoreCase;
 SetTag(StringReplace(((TMenuItem*)(Sender))->Caption,"&","",repl));
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::ListView1Data(TObject *Sender, TListItem *Item) {
 //ListView1->Arrange(Comctrls::arAlignRight);
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::N21Click(TObject *Sender) {
 ListView1->SetFocus();
 for(int i=0;i<ListView1->Items->Count;i++) {
  if(ListView1->Items->Item[i]->Selected)
   ListView1->Items->Item[i]->Selected=false;
  else ListView1->Items->Item[i]->Selected=true;
 }
}
//---------------------------------------------------------------------------

bool ascending[4];
int ColumnToSort = 0;

void __fastcall TMDIChild::ListView1ColumnClick(TObject *Sender,
      TListColumn *Column) {
 if(ascending[Column->Index]) {
  ascending[Column->Index]=false;
 }
 else if(!ascending[Column->Index]) {
  ascending[Column->Index]=true;
 }
 ColumnToSort = Column->Index;
 ((TCustomListView *)Sender)->AlphaSort();
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::ListView1Compare(TObject *Sender, TListItem *Item1,
      TListItem *Item2, int Data, int &Compare) {
 AnsiString name,name1;
 name=Item1->Caption;
 name1=Item2->Caption;
 if (ColumnToSort == 0) {
  if(ascending[ColumnToSort])
   Compare = CompareText(name,name1);
  if (!ascending[ColumnToSort])
   Compare = CompareText(name1,name);
 }
 else if(ColumnToSort == 1)  {
  if(ascending[ColumnToSort]) {
   int ix = ColumnToSort - 1;
   Compare =
    (StrToInt(Item1->SubItems->Strings[ix])>StrToInt(Item2->SubItems->Strings[ix]));
  }
  if(!ascending[ColumnToSort]) {
   int ix = ColumnToSort - 1;
   Compare =
    (StrToInt(Item1->SubItems->Strings[ix])<StrToInt(Item2->SubItems->Strings[ix]));
  }
 }
 else {
  if(ascending[ColumnToSort]) {
   int ix = ColumnToSort - 1;
   Compare =
     CompareText(Item1->SubItems->Strings[ix], Item2->SubItems->Strings[ix]);
  }
  if(!ascending[ColumnToSort]) {
   int ix = ColumnToSort - 1;
   Compare =
     CompareText(Item2->SubItems->Strings[ix], Item1->SubItems->Strings[ix]);
  }
 }
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::Splitter2Moved(TObject *Sender) {
 Panel1->Left=Panel2->Left+Panel2->Width+Splitter2->Width-2;
 Panel1->Width=Width-(Panel2->Left+Panel2->Width+Splitter2->Width)-2;
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::N37Click(TObject *Sender) {
 SelectByRating(0);
}
void __fastcall TMDIChild::N23Click(TObject *Sender)
{
SelectByRating(1);
}
void __fastcall TMDIChild::n24Click(TObject *Sender) {
 //ListView1->ViewStyle=vsSmallIcon;
 SelectByRating(2);
}
void __fastcall TMDIChild::N26Click(TObject *Sender) {
 SelectByRating(3);
}
void __fastcall TMDIChild::N34Click(TObject *Sender) {
 SelectByRating(4);
}
void __fastcall TMDIChild::N35Click(TObject *Sender) {
 SelectByRating(5);
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::N22Click(TObject *Sender) {
 ListView1->ViewStyle=vsList;
}

void __fastcall TMDIChild::N28Click(TObject *Sender) {
 SetTag(((TMenuItem*)Sender)->Caption);
}

void __fastcall TMDIChild::ListView1DblClick(TObject *Sender) {
 AnsiString str;
 TListItem* Item;
 str=DirectoryListBox1->Directory;
 if(ListView1->Items->Count>0) {
  if(ListView1->Selected!=NULL) {
   if(ListView1->Selected->Data==NULL) {
    Item=ListView1->Selected;
    str = Format("%s\\%s",ARRAYOFCONST((str,Item->Caption)));
   }
   else  {
    Item=ListView1->Selected;
    str = Format("%s\%s",ARRAYOFCONST(((PChar)(Item->Data),Item->Caption)));
   }
  }
  else {
   if(ListView1->Items->Item[0]->Data==NULL) {
    Item=ListView1->Items->Item[0];
    str = Format("%s\\%s",ARRAYOFCONST((str,Item->Caption)));
   }
   else  {
    Item=ListView1->Items->Item[0];
    str = Format("%s\%s",ARRAYOFCONST(((PChar)(Item->Data),Item->Caption)));
   }
  }
  if ((Sender==ListView1&&!SlideShow)||(Sender==MainForm->ToolButton16&&!SlideShow)) {
   TMDIChild1 *Child1=CreateMDIChild1(str,Item);
   MainForm->TabControl1->Tabs->AddObject(ExtractFileName(str)+"  [&X]",Child1);
   MainForm->TabControl1->TabIndex=MainForm->TabControl1->Tabs->Count-1;
  }
  MainForm->TabControl1->Visible=true ? MainForm->TabControl1->Tabs->Count>=0 :MainForm->TabControl1->Tabs->Count==0;
 }
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::FormResize(TObject *Sender) {
 Edit1->Width=Width-Edit1->Left-12;
 Splitter1Moved(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::ListView1KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift) {
 ListView1->OnClick(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::FormCreate(TObject *Sender) {
 ((TMainForm*)(Application->MainForm))->ToolBar1->ParentColor=false;
 ((TMainForm*)(Application->MainForm))->ToolBar1->Transparent=false;
 ((TMainForm*)(Application->MainForm))->ToolBar1->Color=clBtnFace;
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::ListView1ColumnDragged(TObject *Sender) {
 //ListView1->Update();
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
void __fastcall TMDIChild::N20Click(TObject *Sender) {
 ListView1->Selected=NULL;
}
//---------------------------------------------------------------------------
void __fastcall TMDIChild::N38Click(TObject *Sender) {
 ListView1->SelectAll();
}
//---------------------------------------------------------------------------
void __fastcall TMDIChild::N39Click(TObject *Sender) {
 ListView1->OnColumnClick(ListView1,ListView1->Column[0]);
}
//---------------------------------------------------------------------------
void __fastcall TMDIChild::N29Click(TObject *Sender) {
 ListView1->ViewStyle=vsIcon;
}
//---------------------------------------------------------------------------
void __fastcall TMDIChild::N31Click(TObject *Sender) {
 ListView1->ViewStyle=vsReport;
}
//---------------------------------------------------------------------------
void __fastcall TMDIChild::N32Click(TObject *Sender) {
 ListView1->ViewStyle=vsSmallIcon;
}
//---------------------------------------------------------------------------
void __fastcall TMDIChild::N40Click(TObject *Sender) {
 ListView1->OnColumnClick(ListView1,ListView1->Column[1]);
}
//---------------------------------------------------------------------------
void __fastcall TMDIChild::N41Click(TObject *Sender) {
 ListView1->OnColumnClick(ListView1,ListView1->Column[2]);
}
//---------------------------------------------------------------------------
void __fastcall TMDIChild::N42Click(TObject *Sender) {
 ListView1->OnColumnClick(ListView1,ListView1->Column[3]);
}

void __fastcall TMDIChild::ListView1Change(TObject *Sender,
      TListItem *Item, TItemChange Change) {
 MainForm->StatusBar->Panels->Items[0]->Text=AnsiString(" :") +ListView1->Items->Count;
 MainForm->StatusBar->Panels->Items[1]->Text=AnsiString(" :") +ListView1->SelCount;
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::ListView1Deletion(TObject *Sender,
      TListItem *Item) {
 free((PChar)(Item->Data));
 Item->Data=NULL;
 MainForm->StatusBar->Panels->Items[0]->Text=AnsiString(" :") +ListView1->Items->Count;
 MainForm->StatusBar->Panels->Items[1]->Text=AnsiString(" :") +ListView1->SelCount;
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::Image1Click(TObject *Sender) {
 ListView1->OnDblClick(ListView1);
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::CheckListBox1Click(TObject *Sender) {
 AnsiString name,path,Class,Rating;
 Album->ADOQuery1->Close();
 ImageList1->Clear();ImageList2->Clear();
 for(int i=0;i<CheckListBox1->Items->Count;i++)
 if(CheckListBox1->Selected[i]) {
  Album->ADOQuery1->Parameters->ParamByName("aname")->Value =CheckListBox1->Items->Strings[i];
  break;
 }
 Album->ADOQuery1->Open();
 ListView1->Clear();
 while(!Album->ADOQuery1->Eof) {
  name=Album->ADOQuery1->FieldByName("FULLNAME")->AsString;
  Class=Album->ADOQuery1->FieldByName("CLASS")->AsString;
  Rating=Album->ADOQuery1->FieldByName("RATING")->AsString;
  path=ExtractFilePath(name);
  int l1= path.Length()+1;
  PChar s1=new Char[l1];
  strcpy(s1,path.c_str());
  ListView1->AddItem(ExtractFileName(name),(TObject*)s1);
  DWORD filesize;
  HANDLE hFile=CreateFile(name.c_str(),GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,0,NULL);
  filesize=GetFileSize(hFile,NULL);
  CloseHandle(hFile);
  ListView1->Items->Item[ListView1->Items->Count-1]->SubItems->Add(IntToStr(filesize));
  ListView1->Items->Item[ListView1->Items->Count-1]->SubItems->Add(Class);
  ListView1->Items->Item[ListView1->Items->Count-1]->SubItems->Add(Rating);
  Album->ADOQuery1->Next();
 }
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::ComboBox1Change(TObject *Sender) {
 if(ComboBox1->Text=="") {
  ADOQuery5->SQL->Strings[1]="and RATING=(:rating)";
  ADOQuery5->Parameters->ParamByName("rating")->Value =0;
 }
 else if (ComboBox1->Text=="") {
  ADOQuery5->SQL->Strings[1]="";
 }
 else {
  ADOQuery5->SQL->Strings[1]="and RATING=(:rating)";
  ADOQuery5->Parameters->ParamByName("rating")->Value =ComboBox1->Text.ToInt();
 }
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::ComboBox2Change(TObject *Sender) {
 if(ComboBox2->Text=="") {
  ADOQuery5->SQL->Strings[2]="and CLASS=(:class)";
  ADOQuery5->Parameters->ParamByName("class")->Value ="";
 }
 else if (ComboBox2->Text=="") {
  ADOQuery5->SQL->Strings[2]="";
 }
 else {
  ADOQuery5->SQL->Strings[2]="and CLASS=(:class)";
  ADOQuery5->Parameters->ParamByName("class")->Value =ComboBox2->Text.Trim();
 }
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::Button1Click(TObject *Sender) {
 AnsiString name,path,Class,Rating;
 if(Edit2->Text=="") Edit2->OnExit(Edit2);
 ListView1->Clear();
 ImageList1->Clear();
 ImageList2->Clear();
 ADOQuery5->Open();
 ADOQuery5->First();
 if(ADOQuery5->RecordCount>0) while(!ADOQuery5->Eof) {
  name=ADOQuery5->FieldByName("FULLNAME")->AsString;
  Class=ADOQuery5->FieldByName("CLASS")->AsString;
  Rating=ADOQuery5->FieldByName("RATING")->AsString;
  path=ExtractFilePath(name);
  int l1= path.Length()+1;
  PChar s1=new Char[l1];
  strcpy(s1,path.c_str());
  ListView1->AddItem(ExtractFileName(name),(TObject*)s1);
  DWORD filesize;
  HANDLE hFile=CreateFile(name.c_str(),GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING	,0,NULL);
  filesize=GetFileSize(hFile,NULL);
  CloseHandle(hFile);
  ListView1->Items->Item[ListView1->Items->Count-1]->SubItems->Add(IntToStr(filesize));
  ListView1->Items->Item[ListView1->Items->Count-1]->SubItems->Add(Class);
  ListView1->Items->Item[ListView1->Items->Count-1]->SubItems->Add(Rating);
  ADOQuery5->Next();
 }
 ADOQuery5->Close();
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::PageControl1Change(TObject *Sender) {
 if(PageControl1->ActivePage->Caption=="") this->ActiveControl=Edit2;
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::Edit2Exit(TObject *Sender) {
 AnsiString name,path,Class,Rating;
 ADOQuery5->Close();
 ADOQuery5->SQL->Strings[0]=("SELECT * from Images WHERE FULLNAME LIKE (:name1)");
 ADOQuery5->Parameters->ParamByName("name1")->Value =("%"+Edit2->Text+"%") ;
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::FormActivate(TObject *Sender) {
 ((TMainForm*)(Application->MainForm))->ToolBar2->Visible=true;
 ((TMainForm*)(Application->MainForm))->ToolBar1->Visible=false;
}
//---------------------------------------------------------------------------



